(function() {'use strict';

    var Constants = [{
        ID: 11,
        url : "/settings/activity-broadcasts-submit",
        FormData: {
            common : [
                {
                    key: "updateBroadcastSettings",
                    value : "Save changes"
                }
            ],
            0 : [],
            1 : [
                {
                    key: "activity",
                    value : "activity"
                }
            ]
        }
        // Description: 'Turn on/off your activity broadcasts'
    },{
        ID: 12,
        url : "/settings/activity-visibility-submit",
        FormData: {
            common : [
                {
                    key: "updateBroadcastSettings",
                    value : "Save changes"
                }
            ],
            0 : [
                {
                    key: "activityFeed",
                    value : "EVERYONE"
                }
            ],
            1 : [
                {
                    key: "activityFeed",
                    value : "NETWORK"
                }
            ],
            2 : [
                {
                    key: "activityFeed",
                    value : "CONNECTIONS"
                }
            ],
            3 : [
                {
                    key: "activityFeed",
                    value : "HIDE"
                }
            ]
        }
        // Description: 'Who can see your activity feed'
    },{
        ID: 13,
        url : "/settings/data-sharing-submit",
        FormData: {
            common : [],
            0 : [],
            1 : [
                {
                    key: "dataSharingParam",
                    value : "dataSharingParam"
                }
            ]
        }
        // Description: 'Data sharing with third-party applications'
    },{
        ID: 14,
        url : "/settings/enhanced-advertising-submit",
        FormData: {
            common : [],
            0 : [],
            1 : [
                {
                    key: "enhancedAdvertisingParam",
                    value : "enhancedAdvertisingParam"
                },
                {
                    key: "affiliateAdvertisingParam",
                    value : "affiliateAdvertisingParam"
                }
            ]
        }
        // Description: 'Allow enhanced advertising'
    },{
        ID: 16,
        url : "/settings/security-submit",
        FormData: {
            common : [
                {
                    key: "offsitePrivacyManagementParam",
                    value : "offsitePrivacyManagementParam"
                }
            ],
            0 : [],
            1 : [
                {
                    key: "fullSsl",
                    value : "fullSsl"
                }
            ]
        }
        // Description: 'A secure connection will be used when you are browsing LinkedIn.'
    }];

    var FixHelper = function() {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsLinkedIn() ? window.location.protocol + '//' + window.location.host : 'https://www.linkedin.com';
    };
    
    FixHelper.prototype.getValidFixValueByID = function(id) {
        for (var i = 0; i < Constants.length; i++) {
            if (Constants[i]['ID'] == id) {
                return LinkedinScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function(id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (value == possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };
    
    FixHelper.prototype.logHeaderSendData = '[Linkedin Fix -> send data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Linkedin Fix -> handle response data]';
    FixHelper.prototype.getSendData = function(id, value, sessionInfo) {
        var dataSet = null;
        for (var i = 0; i < Constants.length; i++) {
            if (Constants[i]['ID'] == id) {
                dataSet = Constants[i];
                break;
            }
        }
        
        var params = {
            'type' : 'POST',
            'data' : {},
            'dataType' : 'html',
            'url' : this.PROTOCOL_DOMAIN + dataSet.url
        };

        
        
        function addKeyValueIntoForm(targetObject, array){
            TMExt_$.each(array, function(index, param){
                targetObject[param.key] = param.value;
            })
        }
        // set form data
        // sessionInfo
        if(sessionInfo){
            addKeyValueIntoForm(params.data, sessionInfo);
        }
        
        // common
        addKeyValueIntoForm(params.data, dataSet.FormData.common);
        
        // related value
        addKeyValueIntoForm(params.data, dataSet.FormData[value]);

        new SendDataLogger(FixHelper.logHeaderSendData + ' : ' + id, params).getLog();
        return params;
    };
    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(FixHelper.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();
        var fixResult = PUtil.cloneObj(LinkedinFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        fixResult['data'] = data;
        return fixResult;
    };

    window.LinkedinFixHelper = FixHelper;
    window.LinkedinFixHelper_Constants = Constants;
})();