(function() {'use strict';
    
    var ScannerHelper = MTwitterScannerHelper;
    var FixHelper = MTwitterFixHelper;

    var Fixer = function() {
        this.ScannerHelper = new ScannerHelper();
        this.FixHelper = new FixHelper();
        this.responseHeaderFixSingle = MTPFixSingleResponse;
    };

    Fixer.prototype.fixSingle = function(settingList, password, callback) {
        var that = this;
        
        that.FixHelper.performFix(settingList, password, function(data){
            var parseData = that.FixHelper.handleResponse(settingList, data);
            if (!parseData) {
                // web content parse error
                var responseData = new APIResponseHelper(that.responseHeaderFixSingle, ReturnCodeEnum.UNKNOWN_EXCEPTION.code, ReturnCodeEnum.UNKNOWN_EXCEPTION.description, 'unknown error' + data).getResponse();
                PSDebug.error(responseData);
                return callback(responseData);
            }

            var responseData = new APIResponseHelper(that.responseHeaderFixSingle, ReturnCodeEnum.OK.code, ReturnCodeEnum.OK.description, parseData).getResponse();
            PSDebug.log(responseData);
            return callback(responseData);
        });
    };

    window.MTwitterPFixer = Fixer;
})();
