(function() {
    'use strict';
    var Scanner = new MTwitterPScanner();
    
    var FixHelper = function() {
        
    };

    FixHelper.prototype.logHeaderSendData = '[MTwitter Fix -> send data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[MTwitter Fix -> handle response data]';     
    
    FixHelper.prototype.performFix = function(settingList, password, callback) {
        var that = this;
        /*
            1. scan again to get auth info
            2. send fix request
        */
        // step 1
        Scanner.getAuth(function(auth){
            // step 2.
            SendWebRequest(that.getSendData(auth, settingList, password), function(data){
                return callback({});
            });
        })
        
    };
    
    FixHelper.prototype.getSendData = function(auth, settingList, password) {
        /*
            Sample settingList
            {
                11 : 0,
                12 : 1,
                13 : 1,
                14 : 1,
                15 : 1
            }
        */
        var params = {
            'type' : 'POST',
            'data' : {
                "authenticity_token" : auth,
                "settings[discoverable_by_email]" : settingList['12'],
                "settings[discoverable_by_mobile_phone]" : settingList['13'],
                "settings[geo_enabled]" : settingList['14'],
                "settings[display_sensitive_media]" : settingList['15'],
                "settings[protected]" : settingList['11'],
                "settings[password]" : password,
                "commit" : "Save"
            },
            'dataType' : 'html',
            'url' : "https://mobile.twitter.com/account/settings"
        };
        
        new SendDataLogger(this.logHeaderSendData + ' : ' + 'getSendData_SettingPage', params).getLog();
        return params;
    };
    
    FixHelper.prototype.handleResponse = function(settingList, data) {
        return {};
    };


    window.MTwitterFixHelper = FixHelper;
})();
