(function() {'use strict';

    // ================================================
    // SendDataConstructor
    // ================================================
    var ScanResultsTemplate = MTwitterScanResultsTemplate;

    var ScannerHelper = function() {
        this.PROTOCOL_DOMAIN = window.location.protocol + '//' + window.location.host;
    };
    ScannerHelper.prototype.logHeaderSendData = '[MTwitter Scan -> send data]';
    ScannerHelper.prototype.logHeaderHandleResponseData = '[MTwitter Scan -> handle response data]';

    ScannerHelper.prototype.getSendData_SettingPage = function() {
        var params = {
            'type' : 'GET',
            'data' : null,
            'dataType' : 'html',
            'url' : null
        };

        params.url = this.PROTOCOL_DOMAIN;
        params.url += '/account/settings';
        new SendDataLogger(this.logHeaderSendData + ' : ' + 'getSendData_SettingPage', params).getLog();
        return params;
    };
    
    ScannerHelper.prototype.handleAuth_SettingPage = function(data) {
        /*
         get authenticity_token
         */

        return data.find('[name="authenticity_token"]').val();
    };
    
    ScannerHelper.prototype.handleResponse_SettingPage = function(data) {
        // data is jquery object
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + 'handleResponse_SettingPage', data).getLog();

        var returnResult = {};
        returnResult['scanResult'] = [];
        returnResult['scanResult_incomplete'] = false;
        
        /*
         get protect_my_tweet
         */
        try {
            var protect_my_tweet = this.getScanResultSampleByID('11');
            protect_my_tweet['Current'] = data.find('[id="settings[protected]"]')[0].checked ? 1 : 0;
            protect_my_tweet['Title'] = data.find('label[for="settings[protected]"]').text();
            protect_my_tweet['Title'] = TMExt_$.trim(protect_my_tweet['Title']);
            protect_my_tweet['Desc'] = protect_my_tweet['Title'];

            returnResult['scanResult'].push(protect_my_tweet);
        } catch (e) {
            PSDebug.error(e);
            returnResult['scanResult_incomplete'] = true;
        }
        
        /*
         Let others find me by my email address
         */
        try {
            var protect_my_tweet = this.getScanResultSampleByID('12');
            protect_my_tweet['Current'] = data.find('[id="settings[discoverable_by_email]"]')[0].checked ? 1 : 0;
            protect_my_tweet['Title'] = data.find('label[for="settings[discoverable_by_email]"]').text();
            protect_my_tweet['Title'] = TMExt_$.trim(protect_my_tweet['Title']);
            protect_my_tweet['Desc'] = protect_my_tweet['Title'];

            returnResult['scanResult'].push(protect_my_tweet);
        } catch (e) {
            PSDebug.error(e);
            returnResult['scanResult_incomplete'] = true;
        }
        
        /*
         Let others find me by my phone number
         */
        try {
            var protect_my_tweet = this.getScanResultSampleByID('13');
            protect_my_tweet['Current'] = data.find('[id="settings[discoverable_by_mobile_phone]"]')[0].checked ? 1 : 0;
            protect_my_tweet['Title'] = data.find('label[for="settings[discoverable_by_mobile_phone]"]').text();
            protect_my_tweet['Title'] = TMExt_$.trim(protect_my_tweet['Title']);
            protect_my_tweet['Desc'] = protect_my_tweet['Title'];

            returnResult['scanResult'].push(protect_my_tweet);
        } catch (e) {
            PSDebug.error(e);
            returnResult['scanResult_incomplete'] = true;
        }
        
        /*
         Add location information to my Tweets
         */
        try {
            var protect_my_tweet = this.getScanResultSampleByID('14');
            protect_my_tweet['Current'] = data.find('[id="settings[geo_enabled]"]')[0].checked ? 1 : 0;
            protect_my_tweet['Title'] = data.find('label[for="settings[geo_enabled]"]').text();
            protect_my_tweet['Title'] = TMExt_$.trim(protect_my_tweet['Title']);
            protect_my_tweet['Desc'] = protect_my_tweet['Title'];

            returnResult['scanResult'].push(protect_my_tweet);
        } catch (e) {
            PSDebug.error(e);
            returnResult['scanResult_incomplete'] = true;
        }
        
        /*
         Display media that may contain sensitive content
         */
        try {
            var protect_my_tweet = this.getScanResultSampleByID('15');
            protect_my_tweet['Current'] = data.find('[id="settings[display_sensitive_media]"]')[0].checked ? 1 : 0;
            protect_my_tweet['Title'] = data.find('label[for="settings[display_sensitive_media]"]').text();
            protect_my_tweet['Title'] = TMExt_$.trim(protect_my_tweet['Title']);
            protect_my_tweet['Desc'] = protect_my_tweet['Title'];

            returnResult['scanResult'].push(protect_my_tweet);
        } catch (e) {
            PSDebug.error(e);
            returnResult['scanResult_incomplete'] = true;
        }
        
        

        return returnResult;
    };

    ScannerHelper.prototype.getAllvalidID = function() {
        var allValidID = [];
        for (var i = 0; i < ScanResultsTemplate.length; i++) {
            allValidID.push(ScanResultsTemplate[i]['ID']);
        }
        return allValidID;
    };
    ScannerHelper.prototype.isValidID = function(id) {
        var allValidID = this.getAllvalidID();
        for (var i = 0; i < allValidID.length; i++) {
            if (id == allValidID[i]) {
                return true;
            }
        }
        return false;
    };

    ScannerHelper.prototype.getScanResultSampleByID = function(id) {
        for (var i = 0; i < ScanResultsTemplate.length; i++) {
            if (ScanResultsTemplate[i]['ID'] == id) {
                return PUtil.cloneObj(ScanResultsTemplate[i]);
            }
        }
    };

    window.MTwitterScannerHelper = ScannerHelper;
})();
