(function() {
    'use strict';

    var Constants = [
        {
            ID: 11,
            FixRelated: {
            }
            // Description: 'Protect my Tweets'
        }, {
            ID: 12,
            FixRelated: {
            }
            // Description: 'Let others find me by my email address'
        }, {
            ID: 13,
            FixRelated: {
            }
            // Description: 'Tailor Twitter based on my recent website visits'
        }, {
            ID: 14,
            FixRelated: {
            }
            // Description: 'Add a location to my Tweets'
        }, {
            ID: 15,
            FixRelated: {
            }
            // Description: 'Tailor ads based on information shared by ad partners.'
        }, {
            ID: 16,
            FixRelated: {
            }
            // Description: 'Photo tagging'
        }];


    var FixHelper = function() {
    };

    FixHelper.prototype.logHeaderSendData = '[Twitter Fix -> click data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Twitter Fix -> handle response data]';    
    
    FixHelper.prototype.performFix = function(id, value) {
        var params = null;
        var check_box = null;
        
        function clickCheckBox(check_box) {
            var current_value = check_box[0].checked ? 1 : 0;
            if (value != current_value) {
                check_box.click();
            }
        }
        
        function clickRatio(ratio_index){
            TMExt_$("#allow_media_tagging_fieldset input").eq(ratio_index).click();
        }
        
        try {
            switch (String(id)) {
                case '11':
                    params = 'Protect my Tweets';
                    check_box = TMExt_$('#user_protected');
                    clickCheckBox(check_box);
                    break;
                case '12':
                    params = 'Let others find me by my email address';
                    check_box = TMExt_$('#user_discoverable_by_email');
                    clickCheckBox(check_box);
                    break;
                case '13':
                    params = 'Tailor Twitter based on my recent website visits';
                    check_box = TMExt_$('#use_cookie_personalization');
                    clickCheckBox(check_box);
                    break;
                case '14':
                    params = 'Add a location to my Tweets';
                    check_box = TMExt_$('#user_geo_enabled');
                    clickCheckBox(check_box);
                    break;
                case '15':
                    params = 'Tailor ads based on information shared by ad partners.';
                    check_box = TMExt_$('#allow_ads_personalization');
                    clickCheckBox(check_box);
                    break;
                case '16':
                    params = 'Photo tagging';
                    clickRatio(value);
                    break;
            }

            new SendDataLogger(this.logHeaderSendData + ' : ' + id, params).getLog();
            return true;
        }catch (e) {
            PSDebug.error(e);
            return false;
        }
    };

    FixHelper.prototype.performSave = function() {
        var params = 'Save button';
        var button_save = TMExt_$('#settings_save');
        
        var input_password = TMExt_$('#auth_password');
        if (input_password.is(':visible')) {
            return true;
        }

        function clickSave() {
            button_save.click();
        }

        try {
            clickSave()
            new SendDataLogger(this.logHeaderSendData + ' : ' + 'save button', params).getLog();
            return true;
        }catch (e) {
            PSDebug.error(e);
            return false;
        }
    };

    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();

        if (!data) {
            // when click fail
            return null;
        }

        var fixResult = PUtil.cloneObj(TwitterFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        if (typeof data === 'string') {
            // this is a string
            fixResult['data'] = data.substring(0, 100);
        }else {
            fixResult['data'] = data;
        }

        return fixResult;
    };

    FixHelper.prototype.getValidFixValueByID = function(id) {
        for (var i = 0; i < Constants.length; i++) {
            if (Constants[i]['ID'] == id) {
                return TwitterScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function(id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (value == possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };

    window.TwitterFixHelper = FixHelper;
    window.TwitterFixHelper_Constants = Constants;
})();
